## ros-one-usb-cam 0.3.7-22noble.20251023.0338

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2)
project(usb_cam)

message(STATUS "Searching required modules")
find_package(PkgConfig REQUIRED)
# FFMPEG
pkg_check_modules(avcodec libavcodec REQUIRED)
pkg_check_modules(avutil libavutil REQUIRED)
pkg_check_modules(swscale libswscale REQUIRED)
pkg_check_modules(video4linux libv4l2 REQUIRED)
# OPENCV
find_package(OpenCV REQUIRED)
# Reporting
if(avcodec_FOUND)
    message(STATUS "Found libavcodec: ${avcodec_VERSION}")
endif()
if(avutil_FOUND)
    message(STATUS "Found libavutil: ${avutil_VERSION}")
endif()
if(swscale_FOUND)
    message(STATUS "Found libswscale: ${swscale_VERSION}")
endif()
if(OpenCV_FOUND)
    message(STATUS "Found OpenCV: ${OpenCV_VERSION}")
endif()
if(video4linux_FOUND)
    message(STATUS "Found Video4Linux kernel library: ${video4linux_VERSION}")
endif()

# Catkin
find_package(catkin REQUIRED COMPONENTS
    cv_bridge
    image_transport
    roscpp
    std_msgs
    std_srvs
    sensor_msgs
    camera_info_manager
)
catkin_package(
    INCLUDE_DIRS include
    LIBRARIES usb_cam
)

# Build scenario
option(SUPPRESS_BIND_GLOBAL_PLACEHOLDERS
    "Suppresses Boost >= 1.68 deprecation warning message for global placeholders in boost::bind instantiation"
    ON
)
# Workaround for deprecation message from instantiation of Boost::bind
# Edit for CMake < 3.12 and ROS_DISTRO < melodic by knorth55
if("$ENV{ROS_DISTRO}" STRGREATER "melodic")
    if(SUPPRESS_BIND_GLOBAL_PLACEHOLDERS)
        add_compile_definitions(BOOST_BIND_GLOBAL_PLACEHOLDERS)
    endif()
endif()

include_directories(include)
link_directories(
    ${video4linux_LIBRARY_DIRS}
    ${avcodec_LIBRARY_DIRS}
    ${avutil_LIBRARY_DIRS}
    ${swscale_LIBRARY_DIRS}
)

# Shared V4L2 driver library
set(v4l_driver_SHARED_HEADERS
    include/usb_cam/types.h
    include/usb_cam/util.h
    include/usb_cam/converters.h
    include/usb_cam/camera_driver.h
)
add_library(v4l_driver
    ${v4l_driver_SHARED_HEADERS}
    src/util.cpp
    src/converters.cpp
    src/camera_driver.cpp
)
target_include_directories(v4l_driver PUBLIC
    ${video4linux_INCLUDE_DIRS}
    ${avcodec_INCLUDE_DIRS}
    ${swscale_INCLUDE_DIRS}
    ${avutil_INCLUDE_DIRS}
    ${OpenCV_INCLUDE_DIRS}
)
target_link_libraries(v4l_driver
    ${video4linux_LIBRARIES}
    ${avcodec_LIBRARIES}
    ${avutil_LIBRARIES}
    ${swscale_LIBRARIES}
    ${OpenCV_LIBS}
)

set(usb_cam_SHARED_HEADERS
    include/usb_cam/usb_cam.h
)
add_library(usb_cam
    ${usb_cam_SHARED_HEADERS}
    src/usb_cam.cpp
)
target_include_directories(usb_cam PRIVATE
    ${catkin_INCLUDE_DIRS}
)
target_link_libraries(usb_cam
    ${catkin_LIBRARIES}
    v4l_driver
)

## Declare a cpp executable
add_executable(usb_cam_node
    src/usb_cam_node.cpp
)
target_include_directories(usb_cam_node PRIVATE
    ${catkin_INCLUDE_DIRS}
)
target_link_libraries(usb_cam_node
    usb_cam
    ${catkin_LIBRARIES}
)

# Installation scenario
# Executables and libraries
install(TARGETS ${PROJECT_NAME}_node v4l_driver ${PROJECT_NAME}
    RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
    LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
)
# Launch files
install(DIRECTORY launch/
    DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/launch
    FILES_MATCHING PATTERN "*.launch"
)
# Include files
install(DIRECTORY include/${PROJECT_NAME}/
    DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
    FILES_MATCHING PATTERN "*.h" PATTERN "*.hpp"
)

## ros-one-usb-cam 0.3.7-22jammy.20251023.0341

=== debian/changelog ===
ros-one-usb-cam (0.3.7-22jammy.20251023.0341) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Andrey Vukolov <andrey.vukolov@elettra.eu>  Thu, 23 Oct 2025 03:41:45 +0000

ros-one-usb-cam (0.3.7-0jammy) jammy; urgency=high

  * Merge pull request #234 <https://github.com/ros-drivers/usb_cam/issues/234> from knorth55/add-maintainer
    Add Shingo Kitagawa as maintainer
  * add shingo kitagawa as maintainer
  * Merge pull request #233 <https://github.com/ros-drivers/usb_cam/issues/233> from knorth55/fix-memory-leak
    fix memory leak in usb_cam.cpp
  * fix memory leak in usb_cam.cpp
  * Merge pull request #229 <https://github.com/ros-drivers/usb_cam/issues/229> from knorth55/update-readme
    update readme
  * update readme
    update budges
    format md
    add ros2 branch info
  * Merge pull request #227 <https://github.com/ros-drivers/usb_cam/issues/227> from knorth55/develop-ci
    Adds CI protocols
  * Merge pull request #228 <https://github.com/ros-drivers/usb_cam/issues/228> from knorth55/fix-typo
    not use LINK libraries
  * change workflows name
  * change workflows name
  * not use LINK libraries
  * add github actions
  * add github actions
  * AUTHORS.md - typo fix
  * Added contributors information
  * Workaround for CMake deprecation warning
  * Fixed library names for pkg-config
    - Fixed library names in the pkg-config section of CMakeLists.txt
    - Closes #202 <https://github.com/ros-drivers/usb_cam/issues/202>
  * Added maintainer address
  * Added maintainer address
  * Added proper CMake OpenCV package handler
  * Merge pull request #126 <https://github.com/ros-drivers/usb_cam/issues/126> from benmaidel/feature/unsupported_set_format_options
    allow cameras that do not support setting format options via VIDIOC_S_FMT
  * Added support for BGR24 pixel format
    - Added support for OpenCV BRG24 pixel format
    (supported by Raspberry Pi camera V4L2 kernel drivers)
    Solution by @romainreignier manually merged by @twdragon
    - Untested. Merged in favour of the tests made by @flynneva
    - Closes #97 <https://github.com/ros-drivers/usb_cam/issues/97>
  * Deprecation message workaround for native H.264
    - Added MJPEG pixel format deprecation reset
    (solution by @at-wat)
    - Added native H.264 pixel format deprecation
    workaround.
    TODO: Find a way to start H.264 decoding from the keyframe
    - Added frame parser context for future development
    - Removed possible memory leak in context allocation
    (all libav contexts and packets are now released properly)
    - Closes #72 <https://github.com/ros-drivers/usb_cam/issues/72>
  * Merge branch 'develop' of github.com:ros-drivers/usb_cam into develop
  * Merge pull request #110 <https://github.com/ros-drivers/usb_cam/issues/110> from rmukhia/develop
    Add support for cameras with hardware 'h264' encoding.
  * Merge branch 'develop-h264' into develop
  * Cosmetic fix for old repository URLS
  * Merge branch 'develop' into develop
  * Merge pull request #115 <https://github.com/ros-drivers/usb_cam/issues/115> from lukehutch/develop
    Suppress libav "deprecated pixel format used" mjpeg warnings
  * Merge pull request #125 <https://github.com/ros-drivers/usb_cam/issues/125> from benmaidel/feature/YUV420
    add support for YUV420 (yu12) pixel format
  * Merge pull request #197 <https://github.com/ros-drivers/usb_cam/issues/197> from twdragon/develop
    Full support for last FFMPEG
  * Name mismatch fix
  * Full support for last FFMPEG release
    - Removed deprecated AVPicture API calls
    - Implemented correct instantiation for
    AVFrame structures
    - Minor build fixes
  * Merge branch 'ros-drivers:develop' into develop
  * allow cameras that do not support setting format options via VIDIOC_S_FMT
  * add support for YUV420 (yu12) pixel format
  * Merge pull request #124 <https://github.com/ros-drivers/usb_cam/issues/124> from k-okada/add_noetic
    add noetic .travis.yml
  * add noetic .travis.yml
  * Suppress libav "deprecated pixel format used" mjpeg warnings
  * Updated sample launch file. h264 supported in 'pixel_format' params. A new parameter 'color_format' supports 'yuv422p' and 'yuv420p'
  * Enable h264 encoding to work with cams which supports hardware h264 encoding like Mobius Maxi.
  * Contributors: Andrei Vukolov, Andrey Vukolov, Benjamin Maidel, Evan Flynn, Kei Okada, Luke Hutchison, Raunak Mukhia, Shingo Kitagawa

 -- Andrey Vukolov <andrey.vukolov@elettra.eu>  Fri, 03 Mar 2023 00:00:00 -0000

ros-one-usb-cam (0.3.6-0jammy) jammy; urgency=high

  * .travis.yml: udpate to trusty
  * add AV_ prefix to PIX_FMT_* for X,Y (#71 <https://github.com/ros-drivers/usb_cam/issues/71>)
  * Contributors: Kei Okada

 -- Andrey Vukolov <andrey.vukolov@elettra.eu>  Thu, 15 Jun 2017 00:00:00 -0000

ros-one-usb-cam (0.3.5-0jammy) jammy; urgency=high

  * add ROS Orphaned Package Maintainers to maintainer tag (#69 <https://github.com/ros-drivers/usb_cam/issues/69>)
  * support for Kinetic / Ubuntu 16.04 (#58 <https://github.com/ros-drivers/usb_cam/issues/58>)
    * replace use of deprecated functions in newer ffmpeg/libav versionsffmpeg/libav 55.x (used in ROS Kinetic) deprecated the avcodec_alloc_frame.
  * Add grey scale pixel format. (#45 <https://github.com/ros-drivers/usb_cam/issues/45>)
  * add start/stop capture services (#44 <https://github.com/ros-drivers/usb_cam/issues/44> )
    * better management of start/stop
    * up package.xml
    * add capture service
  * fix bug for byte count in a pixel (3 bytes not 24 bytes) (#40 <https://github.com/ros-drivers/usb_cam/issues/40> )
  * Contributors: Daniel Seifert, Eric Zavesky, Kei Okada, Ludovico Russo, Russell Toris, honeytrap15

 -- Andrey Vukolov <andrey.vukolov@elettra.eu>  Wed, 14 Jun 2017 00:00:00 -0000

ros-one-usb-cam (0.3.4-0jammy) jammy; urgency=high

  * Installs launch files
  * Merge pull request #37 from tzutalin/develop
    Add a launch file for easy test
  * Add a launch file for easy test


=== debian/control ===
Source: ros-one-usb-cam
Section: misc
Priority: optional
Maintainer: Andrey Vukolov <andrey.vukolov@elettra.eu>
Build-Depends: debhelper (>= 9.0.0), ffmpeg, libavcodec-dev, libavformat-dev, libavutil-dev, libswscale-dev, libv4l-dev, ros-one-camera-info-manager, ros-one-catkin, ros-one-cv-bridge, ros-one-image-transport, ros-one-roscpp, ros-one-sensor-msgs, ros-one-std-msgs, ros-one-std-srvs
Homepage: http://wiki.ros.org/usb_cam
Standards-Version: 3.9.2

Package: ros-one-usb-cam
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ffmpeg, libavcodec-dev, libavformat-dev, libavutil-dev, libswscale-dev, libv4l-dev, ros-one-camera-info-manager, ros-one-cv-bridge, ros-one-image-transport, ros-one-roscpp, ros-one-sensor-msgs, ros-one-std-msgs, ros-one-std-srvs
Description: A ROS Driver for V4L USB Cameras

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/one/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF -DCATKIN_ENABLE_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_configure -- \
		-DFETCHCONTENT_FULLY_DISCONNECTED=OFF \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/one" \
		-DCMAKE_PREFIX_PATH="/opt/ros/one" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-one-usb-cam//opt/ros/one/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_install

## ros-one-usb-cam 0.3.7-22jammy.20260221.0020

=== debian/changelog ===
ros-one-usb-cam (0.3.7-22jammy.20260221.0020) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Andrey Vukolov <andrey.vukolov@elettra.eu>  Sat, 21 Feb 2026 00:20:41 +0000

## ros-one-usb-cam 0.3.7-22noble.20251023.0338

=== debian/changelog ===
ros-one-usb-cam (0.3.7-22noble.20251023.0338) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Andrey Vukolov <andrey.vukolov@elettra.eu>  Thu, 23 Oct 2025 03:38:54 +0000

ros-one-usb-cam (0.3.7-0noble) noble; urgency=high

  * Merge pull request #234 <https://github.com/ros-drivers/usb_cam/issues/234> from knorth55/add-maintainer
    Add Shingo Kitagawa as maintainer
  * add shingo kitagawa as maintainer
  * Merge pull request #233 <https://github.com/ros-drivers/usb_cam/issues/233> from knorth55/fix-memory-leak
    fix memory leak in usb_cam.cpp
  * fix memory leak in usb_cam.cpp
  * Merge pull request #229 <https://github.com/ros-drivers/usb_cam/issues/229> from knorth55/update-readme
    update readme
  * update readme
    update budges
    format md
    add ros2 branch info
  * Merge pull request #227 <https://github.com/ros-drivers/usb_cam/issues/227> from knorth55/develop-ci
    Adds CI protocols
  * Merge pull request #228 <https://github.com/ros-drivers/usb_cam/issues/228> from knorth55/fix-typo
    not use LINK libraries
  * change workflows name
  * change workflows name
  * not use LINK libraries
  * add github actions
  * add github actions
  * AUTHORS.md - typo fix
  * Added contributors information
  * Workaround for CMake deprecation warning
  * Fixed library names for pkg-config
    - Fixed library names in the pkg-config section of CMakeLists.txt
    - Closes #202 <https://github.com/ros-drivers/usb_cam/issues/202>
  * Added maintainer address
  * Added maintainer address
  * Added proper CMake OpenCV package handler
  * Merge pull request #126 <https://github.com/ros-drivers/usb_cam/issues/126> from benmaidel/feature/unsupported_set_format_options
    allow cameras that do not support setting format options via VIDIOC_S_FMT
  * Added support for BGR24 pixel format
    - Added support for OpenCV BRG24 pixel format
    (supported by Raspberry Pi camera V4L2 kernel drivers)
    Solution by @romainreignier manually merged by @twdragon
    - Untested. Merged in favour of the tests made by @flynneva
    - Closes #97 <https://github.com/ros-drivers/usb_cam/issues/97>
  * Deprecation message workaround for native H.264
    - Added MJPEG pixel format deprecation reset
    (solution by @at-wat)
    - Added native H.264 pixel format deprecation
    workaround.
    TODO: Find a way to start H.264 decoding from the keyframe
    - Added frame parser context for future development
    - Removed possible memory leak in context allocation
    (all libav contexts and packets are now released properly)
    - Closes #72 <https://github.com/ros-drivers/usb_cam/issues/72>
  * Merge branch 'develop' of github.com:ros-drivers/usb_cam into develop
  * Merge pull request #110 <https://github.com/ros-drivers/usb_cam/issues/110> from rmukhia/develop
    Add support for cameras with hardware 'h264' encoding.
  * Merge branch 'develop-h264' into develop
  * Cosmetic fix for old repository URLS
  * Merge branch 'develop' into develop
  * Merge pull request #115 <https://github.com/ros-drivers/usb_cam/issues/115> from lukehutch/develop
    Suppress libav "deprecated pixel format used" mjpeg warnings
  * Merge pull request #125 <https://github.com/ros-drivers/usb_cam/issues/125> from benmaidel/feature/YUV420
    add support for YUV420 (yu12) pixel format
  * Merge pull request #197 <https://github.com/ros-drivers/usb_cam/issues/197> from twdragon/develop
    Full support for last FFMPEG
  * Name mismatch fix
  * Full support for last FFMPEG release
    - Removed deprecated AVPicture API calls
    - Implemented correct instantiation for
    AVFrame structures
    - Minor build fixes
  * Merge branch 'ros-drivers:develop' into develop
  * allow cameras that do not support setting format options via VIDIOC_S_FMT
  * add support for YUV420 (yu12) pixel format
  * Merge pull request #124 <https://github.com/ros-drivers/usb_cam/issues/124> from k-okada/add_noetic
    add noetic .travis.yml
  * add noetic .travis.yml
  * Suppress libav "deprecated pixel format used" mjpeg warnings
  * Updated sample launch file. h264 supported in 'pixel_format' params. A new parameter 'color_format' supports 'yuv422p' and 'yuv420p'
  * Enable h264 encoding to work with cams which supports hardware h264 encoding like Mobius Maxi.
  * Contributors: Andrei Vukolov, Andrey Vukolov, Benjamin Maidel, Evan Flynn, Kei Okada, Luke Hutchison, Raunak Mukhia, Shingo Kitagawa

 -- Andrey Vukolov <andrey.vukolov@elettra.eu>  Fri, 03 Mar 2023 00:00:00 -0000

ros-one-usb-cam (0.3.6-0noble) noble; urgency=high

  * .travis.yml: udpate to trusty
  * add AV_ prefix to PIX_FMT_* for X,Y (#71 <https://github.com/ros-drivers/usb_cam/issues/71>)
  * Contributors: Kei Okada

 -- Andrey Vukolov <andrey.vukolov@elettra.eu>  Thu, 15 Jun 2017 00:00:00 -0000

ros-one-usb-cam (0.3.5-0noble) noble; urgency=high

  * add ROS Orphaned Package Maintainers to maintainer tag (#69 <https://github.com/ros-drivers/usb_cam/issues/69>)
  * support for Kinetic / Ubuntu 16.04 (#58 <https://github.com/ros-drivers/usb_cam/issues/58>)
    * replace use of deprecated functions in newer ffmpeg/libav versionsffmpeg/libav 55.x (used in ROS Kinetic) deprecated the avcodec_alloc_frame.
  * Add grey scale pixel format. (#45 <https://github.com/ros-drivers/usb_cam/issues/45>)
  * add start/stop capture services (#44 <https://github.com/ros-drivers/usb_cam/issues/44> )
    * better management of start/stop
    * up package.xml
    * add capture service
  * fix bug for byte count in a pixel (3 bytes not 24 bytes) (#40 <https://github.com/ros-drivers/usb_cam/issues/40> )
  * Contributors: Daniel Seifert, Eric Zavesky, Kei Okada, Ludovico Russo, Russell Toris, honeytrap15

 -- Andrey Vukolov <andrey.vukolov@elettra.eu>  Wed, 14 Jun 2017 00:00:00 -0000

ros-one-usb-cam (0.3.4-0noble) noble; urgency=high

  * Installs launch files
  * Merge pull request #37 from tzutalin/develop
    Add a launch file for easy test
  * Add a launch file for easy test


## ros-one-usb-cam 0.3.7-22noble.20260221.0048

=== debian/changelog ===
ros-one-usb-cam (0.3.7-22noble.20260221.0048) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Andrey Vukolov <andrey.vukolov@elettra.eu>  Sat, 21 Feb 2026 00:48:06 +0000
